=== tutorials/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

project(dart-tutorials)

add_subdirectory(tutorialBiped)
add_subdirectory(tutorialBiped-Finished)
add_subdirectory(tutorialCollisions)
add_subdirectory(tutorialCollisions-Finished)
add_subdirectory(tutorialDominoes)
add_subdirectory(tutorialDominoes-Finished)
add_subdirectory(tutorialMultiPendulum)
add_subdirectory(tutorialMultiPendulum-Finished)
