=== debian/changelog ===
ros-kinetic-dartsim (6.3.1-2xenial) xenial; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Michael X. Grey <grey@openrobotics.org>  Thu, 22 Mar 2018 00:04:09 -0000
